## pentobi 16.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(Pentobi)
set(PENTOBI_VERSION 16.2)
set(PENTOBI_RELEASE_DATE 2019-01-16)

cmake_policy(SET CMP0043 NEW)
cmake_policy(SET CMP0071 NEW)

include(GNUInstallDirs)

option(PENTOBI_BUILD_GTP "Build GTP interface" OFF)
option(PENTOBI_BUILD_GUI "Build GUI" ON)
option(PENTOBI_BUILD_TESTS "Build unit tests" OFF)
option(PENTOBI_BUILD_THUMBNAILER "Build Gnome thumbnailer" ON)
option(PENTOBI_BUILD_KDE_THUMBNAILER "Build KDE thumbnailer" OFF)
option(PENTOBI_OPEN_HELP_EXTERNALLY "Force using web browser for displaying help" OFF)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "No build type selected, default to Release")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "" FORCE)
endif()

set(CMAKE_CXX_STANDARD 14)
if(CMAKE_COMPILER_IS_GNUCXX OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
  add_compile_options(-ffast-math -Wall -Wextra)
endif()

if(PENTOBI_BUILD_TESTS)
  if(PENTOBI_BUILD_KDE_THUMBNAILER)
    configure_file(CTestCustom.cmake ${CMAKE_BINARY_DIR} COPYONLY)
  endif()
  enable_testing()
endif()

if(UNIX)
  add_custom_target(dist
    COMMAND git archive --prefix=pentobi-${PENTOBI_VERSION}/ HEAD
    | xz -e > ${CMAKE_BINARY_DIR}/pentobi-${PENTOBI_VERSION}.tar.xz
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif()

add_subdirectory(doc)
add_subdirectory(src)
add_subdirectory(data)

=== doc/CMakeLists.txt ===
if(PENTOBI_BUILD_GUI)
    install(DIRECTORY help DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}
        FILES_MATCHING PATTERN "*.css" PATTERN "*.html" PATTERN "*.png"
        PATTERN "*.jpg")
endif()

add_subdirectory(man)

=== src/CMakeLists.txt ===
add_subdirectory(libboardgame_sys)
add_subdirectory(libboardgame_util)
add_subdirectory(libboardgame_sgf)
add_subdirectory(libboardgame_base)
add_subdirectory(libpentobi_base)
if(PENTOBI_BUILD_GUI OR PENTOBI_BUILD_GTP)
    add_subdirectory(libboardgame_mcts)
    add_subdirectory(libpentobi_mcts)
endif()
if(PENTOBI_BUILD_GTP)
    add_subdirectory(libboardgame_gtp)
    add_subdirectory(pentobi_gtp)
    if(HAVE_UNISTD_H AND NOT WIN32)
        add_subdirectory(twogtp)
    else()
        message(STATUS "Not building twogtp, needs POSIX")
    endif()
    add_subdirectory(learn_tool)
endif()
if(PENTOBI_BUILD_GUI OR PENTOBI_BUILD_THUMBNAILER)
    add_subdirectory(libpentobi_paint)
endif()
if(PENTOBI_BUILD_GUI)
    add_subdirectory(convert)
    add_subdirectory(pentobi)
endif()
if(PENTOBI_BUILD_TESTS)
    add_subdirectory(libboardgame_test)
    add_subdirectory(unittest)
endif()
if(PENTOBI_BUILD_THUMBNAILER)
    add_subdirectory(libpentobi_thumbnail)
    add_subdirectory(pentobi_thumbnailer)
endif()
if(PENTOBI_BUILD_KDE_THUMBNAILER)
    add_subdirectory(libpentobi_kde_thumbnailer)
    add_subdirectory(pentobi_kde_thumbnailer)
endif()

=== doc/man/CMakeLists.txt ===
configure_file(pentobi.6.in pentobi.6 @ONLY)
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/pentobi.6
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man6)

if(PENTOBI_BUILD_THUMBNAILER)
    configure_file(pentobi-thumbnailer.6.in pentobi-thumbnailer.6 @ONLY)
    install(FILES
      ${CMAKE_CURRENT_BINARY_DIR}/pentobi-thumbnailer.6
      DESTINATION ${CMAKE_INSTALL_MANDIR}/man6)
endif()

=== src/convert/CMakeLists.txt ===
find_package(Qt5Gui REQUIRED)

add_executable(convert Main.cpp)

target_link_libraries(convert Qt5::Gui)

=== src/libboardgame_base/CMakeLists.txt ===
set(boardgame_base_SRCS
    CoordPoint.h
    CoordPoint.cpp
    Geometry.h
    GeometryUtil.h
    Grid.h
    Marker.h
    Point.h
    PointTransform.h
    Rating.h
    Rating.cpp
    RectGeometry.h
    RectTransform.h
    RectTransform.cpp
    StringRep.h
    StringRep.cpp
    Transform.h
    Transform.cpp
    )
if (PENTOBI_BUILD_GTP)
    set(boardgame_base_SRCS ${boardgame_base_SRCS}
        Engine.cpp
        Engine.h
        )
endif()

add_library(boardgame_base STATIC ${boardgame_base_SRCS})

target_link_libraries(boardgame_base boardgame_util)
if (PENTOBI_BUILD_GTP)
    target_link_libraries(boardgame_base boardgame_gtp)
endif()

target_include_directories(boardgame_base PUBLIC ..)

=== src/libboardgame_gtp/CMakeLists.txt ===
add_library(boardgame_gtp STATIC
  Arguments.h
  Arguments.cpp
  CmdLine.h
  CmdLine.cpp
  CmdLineRange.h
  Engine.h
  Engine.cpp
  Failure.h
  Response.h
  Response.cpp
)

target_include_directories(boardgame_gtp PUBLIC ..)

=== src/libboardgame_mcts/CMakeLists.txt ===
option(LIBBOARDGAME_MCTS_SINGLE_THREAD
    "Slightly faster MCTS search if only single-threaded search is used" OFF)

find_package(Threads)

add_library(boardgame_mcts INTERFACE)

if(LIBBOARDGAME_MCTS_SINGLE_THREAD)
  target_compile_definitions(boardgame_mcts INTERFACE
      LIBBOARDGAME_MCTS_SINGLE_THREAD)
endif()

target_include_directories(boardgame_mcts INTERFACE ..)

target_link_libraries(boardgame_mcts INTERFACE
    boardgame_util
    Threads::Threads
    )

=== src/libboardgame_sgf/CMakeLists.txt ===
add_library(boardgame_sgf STATIC
  Reader.h
  Reader.cpp
  SgfError.h
  SgfError.cpp
  SgfNode.h
  SgfNode.cpp
  SgfTree.h
  SgfTree.cpp
  SgfUtil.h
  SgfUtil.cpp
  TreeReader.h
  TreeReader.cpp
  TreeWriter.h
  TreeWriter.cpp
  Writer.h
  Writer.cpp
)

target_include_directories(boardgame_sgf PUBLIC ..)

target_link_libraries(boardgame_sgf boardgame_util)

=== src/libboardgame_sys/CMakeLists.txt ===
include(CheckIncludeFiles)

add_library(boardgame_sys STATIC
  Compiler.h
  CpuTime.h
  CpuTime.cpp
  Memory.h
  Memory.cpp
)

check_include_files(sys/sysctl.h HAVE_SYS_SYSCTL_H)
if(HAVE_SYS_SYSCTL_H)
    target_compile_definitions(boardgame_sys PRIVATE HAVE_SYS_SYSCTL_H)
endif()
check_include_files(sys/times.h HAVE_SYS_TIMES_H)
if(HAVE_SYS_TIMES_H)
    target_compile_definitions(boardgame_sys PRIVATE HAVE_SYS_TIMES_H)
endif()
check_include_files(unistd.h HAVE_UNISTD_H)
if(HAVE_UNISTD_H)
    target_compile_definitions(boardgame_sys PRIVATE HAVE_UNISTD_H)
endif()

target_include_directories(boardgame_sys PUBLIC ..)

=== src/libboardgame_test/CMakeLists.txt ===
add_library(boardgame_test STATIC
  Test.h
  Test.cpp
)

target_include_directories(boardgame_test PUBLIC ..)

target_link_libraries(boardgame_test boardgame_util)

add_library(boardgame_test_main STATIC Main.cpp)

target_link_libraries(boardgame_test_main boardgame_test)

=== src/libboardgame_util/CMakeLists.txt ===
add_library(boardgame_util STATIC
  Abort.h
  Abort.cpp
  ArrayList.h
  Assert.h
  Assert.cpp
  Barrier.h
  Barrier.cpp
  CpuTimeSource.h
  CpuTimeSource.cpp
  FmtSaver.h
  IntervalChecker.h
  IntervalChecker.cpp
  Log.h
  Log.cpp
  MathUtil.h
  Options.h
  Options.cpp
  RandomGenerator.h
  RandomGenerator.cpp
  Range.h
  Statistics.h
  StringUtil.h
  StringUtil.cpp
  TimeIntervalChecker.h
  TimeIntervalChecker.cpp
  Timer.h
  Timer.cpp
  TimeSource.h
  TimeSource.cpp
  Unused.h
  WallTimeSource.h
  WallTimeSource.cpp
)

target_compile_options(boardgame_util PUBLIC
    "$<$<CONFIG:DEBUG>:-DLIBBOARDGAME_DEBUG>")

target_include_directories(boardgame_util PUBLIC ..)

target_link_libraries(boardgame_util boardgame_sys)

=== debian/changelog ===
pentobi (16.2.1-1+eagle) unstable; urgency=medium

  * update

 -- Debian Games Team <pkg-games-devel@lists.alioth.debian.org>  Thu, 28 Jan 2021 19:42:37 +0800

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT = qt5
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Optimize with O3 to make the computationally expensive higher levels faster.
ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
  export DEB_CXXFLAGS_MAINT_APPEND = -O3
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_BINDIR=/usr/games \
		-DCMAKE_INSTALL_DATADIR=/usr/share/games \
		-DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
		-DPENTOBI_BUILD_KDE_THUMBNAILER=ON \
		-DPENTOBI_BUILD_TESTS=ON

# dh_makeshlibs not needed, the KDE thumbnailer .so file is a plugin.
override_dh_makeshlibs:

## pentobi 17.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(Pentobi)
set(PENTOBI_VERSION 17.1)
set(PENTOBI_RELEASE_DATE 2019-06-12)

cmake_policy(SET CMP0043 NEW)
cmake_policy(SET CMP0071 NEW)

include(GNUInstallDirs)

option(PENTOBI_BUILD_GTP "Build GTP interface" OFF)
option(PENTOBI_BUILD_GUI "Build GUI" ON)
option(PENTOBI_BUILD_THUMBNAILER "Build Gnome thumbnailer" ${UNIX})
option(PENTOBI_BUILD_KDE_THUMBNAILER "Build KDE thumbnailer" OFF)
option(PENTOBI_OPEN_HELP_EXTERNALLY "Force using web browser for displaying help" OFF)
option(BUILD_TESTING "Build tests" OFF)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "No build type selected, default to Release")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "" FORCE)
endif()

set(CMAKE_CXX_STANDARD 17)
if(CMAKE_COMPILER_IS_GNUCXX OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
  add_compile_options(-ffast-math -Wall -Wextra)
endif()

if(BUILD_TESTING)
  if(PENTOBI_BUILD_KDE_THUMBNAILER)
    configure_file(pentobi_kde_thumbnailer/CTestCustom.cmake
        ${CMAKE_BINARY_DIR} COPYONLY)
  endif()
  enable_testing()
endif()

if(UNIX)
  add_custom_target(dist
    COMMAND git archive --prefix=pentobi-${PENTOBI_VERSION}/ HEAD
    | xz -e > ${CMAKE_BINARY_DIR}/pentobi-${PENTOBI_VERSION}.tar.xz
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif()

add_subdirectory(libboardgame_base)
add_subdirectory(libpentobi_base)
if(BUILD_TESTING)
    add_subdirectory(libboardgame_test)
endif()
if(PENTOBI_BUILD_GUI OR PENTOBI_BUILD_GTP)
    add_subdirectory(libboardgame_mcts)
    add_subdirectory(libpentobi_mcts)
endif()
if(PENTOBI_BUILD_GTP)
    add_subdirectory(libboardgame_gtp)
    add_subdirectory(libpentobi_gtp)
    add_subdirectory(pentobi_gtp)
    if(UNIX)
        add_subdirectory(twogtp)
    else()
        message(STATUS "Not building twogtp, needs POSIX")
    endif()
    add_subdirectory(learn_tool)
endif()
if(PENTOBI_BUILD_GUI)
    add_subdirectory(libpentobi_paint)
    add_subdirectory(pentobi)
    if(PENTOBI_BUILD_THUMBNAILER)
        add_subdirectory(libpentobi_thumbnail)
        add_subdirectory(pentobi_thumbnailer)
    endif()
endif()
if(PENTOBI_BUILD_KDE_THUMBNAILER)
    add_subdirectory(libpentobi_kde_thumbnailer)
    add_subdirectory(pentobi_kde_thumbnailer)
endif()

=== pentobi/CMakeLists.txt ===
set(CMAKE_AUTOMOC TRUE)

find_package(Threads)
find_package(Qt5Concurrent 5.11 REQUIRED)
find_package(Qt5QuickControls2 5.11 REQUIRED)
find_package(Qt5LinguistTools 5.11 REQUIRED)
find_package(Qt5Svg 5.11 REQUIRED)
find_package(Qt5WebView 5.11 QUIET)

qt5_add_translation(pentobi_QM
    qml/i18n/qml_de.ts
    qml/i18n/qml_fr.ts
    qml/i18n/qml_nb_NO.ts
    qml/i18n/qml_zh_CN.ts
    OPTIONS -removeidentical -nounfinished
    )
add_custom_command(
    OUTPUT "translations.qrc"
    COMMAND ${CMAKE_COMMAND} -E copy
    "${CMAKE_CURRENT_SOURCE_DIR}/qml/i18n/translations.qrc" .
    DEPENDS qml/i18n/translations.qrc ${pentobi_QM}
    )

qt5_add_resources(pentobi_RC_SRCS
    "${CMAKE_CURRENT_BINARY_DIR}/translations.qrc"
    ../opening_books/pentobi_books.qrc
    icon/pentobi_icon.qrc
    resources.qrc
    resources_desktop.qrc
    qml/themes/themes.qrc
    )

add_executable(pentobi WIN32
    ${pentobi_RC_SRCS}
    AnalyzeGameModel.h
    AnalyzeGameModel.cpp
    AndroidUtils.h
    AndroidUtils.cpp
    GameModel.h
    GameModel.cpp
    ImageProvider.h
    ImageProvider.cpp
    Main.cpp
    PieceModel.h
    PieceModel.cpp
    PlayerModel.h
    PlayerModel.cpp
    RatingModel.h
    RatingModel.cpp
    SyncSettings.h
    )

file(GLOB qml_SRC "qml/*.qml" "qml/*.js" "qml/i18n/*.ts" "qml/themes/*/*.qml")
target_sources(pentobi PRIVATE ${qml_SRC})

target_compile_definitions(pentobi PRIVATE
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x051200
    QT_NO_NARROWING_CONVERSIONS_IN_CONNECT
    PENTOBI_HELP_DIR="${CMAKE_INSTALL_FULL_DATAROOTDIR}/help"
    VERSION="${PENTOBI_VERSION}"
    )

target_link_libraries(pentobi
    pentobi_paint
    pentobi_mcts
    Qt5::Concurrent
    Qt5::Qml
    Qt5::QuickControls2
    Qt5::Svg
    Threads::Threads
    )

if(Qt5WebView_FOUND AND NOT PENTOBI_OPEN_HELP_EXTERNALLY)
    target_link_libraries(pentobi Qt5::WebView)
else()
    if(NOT Qt5WebView_FOUND AND NOT PENTOBI_OPEN_HELP_EXTERNALLY)
        message(WARNING
            "Qt5WebView not found, setting PENTOBI_OPEN_HELP_EXTERNALLY")
    endif()
    target_compile_definitions(pentobi PRIVATE PENTOBI_OPEN_HELP_EXTERNALLY)
endif()

install(TARGETS pentobi DESTINATION ${CMAKE_INSTALL_BINDIR})

add_subdirectory(docbook)
if(UNIX)
    add_subdirectory(unix)
endif()

=== pentobi_thumbnailer/CMakeLists.txt ===
find_package(Qt5Core 5.11 REQUIRED)
find_package(Qt5LinguistTools 5.11 REQUIRED)
find_package(Gettext 0.18 REQUIRED)
find_program(ITSTOOL itstool)
if(NOT ITSTOOL)
    message(FATAL_ERROR "itstool not found")
endif()
find_program(XSLTPROC xsltproc)
if(NOT XSLTPROC)
    message(FATAL_ERROR "xsltproc not found")
endif()
find_path(DOCBOOK_XSL manpages/docbook.xsl
    HINTS /usr/share/xml/docbook/stylesheet/docbook-xsl
    /usr/local/share/xml/docbook/stylesheet/docbook-xsl
    /usr/share/xsl/docbook /usr/local/share/xsl/docbook
    )
if(NOT DOCBOOK_XSL)
    message(FATAL_ERROR "docbook-xsl not found")
endif()

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/po/LINGUAS" linguas)
string(REGEX REPLACE "\n" ";" linguas "${linguas}")

set(man_files "pentobi-thumbnailer.6")
foreach(lang ${linguas})
    list(APPEND man_files ${lang}/pentobi-thumbnailer.6)
endforeach()

foreach(lang ${linguas})
    add_custom_command(OUTPUT ${lang}.mo
        COMMAND "${GETTEXT_MSGFMT_EXECUTABLE}" -o ${lang}.mo
        "${CMAKE_CURRENT_SOURCE_DIR}/po/${lang}.po"
        DEPENDS po/${lang}.po
        )
    list(APPEND po_files po/${lang}.po)
    list(APPEND mo_files ${lang}.mo)
endforeach()

qt5_add_translation(pentobi_thumbnailer_QM
    i18n/de.ts
    OPTIONS -removeidentical -nounfinished
    )
add_custom_command(
    OUTPUT "translations.qrc"
    COMMAND ${CMAKE_COMMAND} -E copy
    ${CMAKE_CURRENT_SOURCE_DIR}/i18n/translations.qrc .
    DEPENDS i18n/translations.qrc ${pentobi_thumbnailer_QM}
    )

qt5_add_resources(pentobi_thumbnailer_RC_SRCS
    ${CMAKE_CURRENT_BINARY_DIR}/translations.qrc
    )

add_executable(pentobi-thumbnailer
    Main.cpp
    ${pentobi_thumbnailer_RC_SRCS}
    ${man_files}
    )

target_link_libraries(pentobi-thumbnailer pentobi_thumbnail)

target_compile_definitions(pentobi-thumbnailer PRIVATE
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x051200
    VERSION="${PENTOBI_VERSION}"
    )

configure_file(pentobi.thumbnailer.in pentobi.thumbnailer @ONLY)

install(TARGETS pentobi-thumbnailer DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pentobi.thumbnailer
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/thumbnailers)

# Man page

configure_file(pentobi-thumbnailer-manpage.docbook.in
    pentobi-thumbnailer-manpage.docbook @ONLY)
add_custom_command(OUTPUT pentobi-thumbnailer.6
    COMMAND "${XSLTPROC}" --nonet --novalid --path "${DOCBOOK_XSL}/manpages"
    "${CMAKE_CURRENT_SOURCE_DIR}/../pentobi/unix/manpage.xsl"
    pentobi-thumbnailer-manpage.docbook
    DEPENDS
    "${CMAKE_CURRENT_BINARY_DIR}/pentobi-thumbnailer-manpage.docbook"
    ../pentobi/unix/manpage.xsl
)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/pentobi-thumbnailer.6"
    DESTINATION "${CMAKE_INSTALL_MANDIR}/man6")
foreach(lang ${linguas})
    add_custom_command(OUTPUT ${lang}/pentobi-thumbnailer-manpage.docbook
        COMMAND ${CMAKE_COMMAND} -E make_directory ${lang}
        COMMAND "${ITSTOOL}" -l ${lang} -m ${lang}.mo
        -o ${lang}/pentobi-thumbnailer-manpage.docbook
        -i "${CMAKE_CURRENT_SOURCE_DIR}/../pentobi/unix/manpage.its"
        pentobi-thumbnailer-manpage.docbook
        DEPENDS ${lang}.mo "${CMAKE_CURRENT_BINARY_DIR}/pentobi-thumbnailer-manpage.docbook"
        )
    add_custom_command(OUTPUT ${lang}/pentobi-thumbnailer.6
        COMMAND "${XSLTPROC}" --nonet --novalid
        --path "${DOCBOOK_XSL}/manpages" -o ${lang}/
        "${CMAKE_CURRENT_SOURCE_DIR}/../pentobi/unix/manpage.xsl"
        ${lang}/pentobi-thumbnailer-manpage.docbook
        DEPENDS
        "${CMAKE_CURRENT_BINARY_DIR}/${lang}/pentobi-thumbnailer-manpage.docbook"
        ../pentobi/unix/manpage.xsl
        )
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${lang}/pentobi-thumbnailer.6"
        DESTINATION "${CMAKE_INSTALL_MANDIR}/${lang}/man6")
endforeach()

=== pentobi/docbook/CMakeLists.txt ===
find_package(Gettext 0.18 REQUIRED)
find_program(ITSTOOL itstool)
if(NOT ITSTOOL)
    message(FATAL_ERROR "itstool not found")
endif()
find_program(XSLTPROC xsltproc)
if(NOT XSLTPROC)
    message(FATAL_ERROR "xsltproc not found")
endif()
find_path(DOCBOOK_XSL html/chunk.xsl
    HINTS /usr/share/xml/docbook/stylesheet/docbook-xsl
    /usr/local/share/xml/docbook/stylesheet/docbook-xsl
    /usr/share/xsl/docbook /usr/local/share/xsl/docbook
    /usr/share/xml/docbook/stylesheet/nwalsh/current
    )
if(NOT DOCBOOK_XSL)
    message(FATAL_ERROR "docbook-xsl not found")
endif()

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/po/LINGUAS" linguas)
string(REGEX REPLACE "\n" ";" linguas "${linguas}")

set(DOCBOOK_SRC
    custom.xsl
    index.docbook
    figures/analysis.jpg
    figures/board_callisto.png
    figures/board_classic.png
    figures/board_duo.png
    figures/board_gembloq.png
    figures/board_nexos.png
    figures/board_trigon.jpg
    figures/pieces_callisto.png
    figures/pieces_gembloq.jpg
    figures/pieces_junior.png
    figures/pieces_nexos.png
    figures/pieces.png
    figures/pieces_trigon.jpg
    figures/position_callisto.png
    figures/position_classic.png
    figures/position_duo.png
    figures/position_gembloq.png
    figures/position_nexos.png
    figures/position_trigon.jpg
    figures/rating.jpg
    figures/stylesheet.css
    )

foreach(lang ${linguas})
    add_custom_command(OUTPUT ${lang}.mo
        COMMAND "${GETTEXT_MSGFMT_EXECUTABLE}" -o ${lang}.mo
        "${CMAKE_CURRENT_SOURCE_DIR}/po/${lang}.po"
        DEPENDS po/${lang}.po
        )
    list(APPEND index_files "help/${lang}/pentobi/index.html")
    add_custom_command(OUTPUT "index_${lang}.docbook"
        COMMAND "${ITSTOOL}" -m ${lang}.mo -o "index_${lang}.docbook"
        "${CMAKE_CURRENT_SOURCE_DIR}/index.docbook"
        DEPENDS index.docbook ${lang}.mo
        )
    add_custom_command(OUTPUT "help/${lang}/pentobi/index.html"
        COMMAND "${XSLTPROC}" --nonet --novalid --path "${DOCBOOK_XSL}/html"
        --stringparam l10n.gentext.language ${lang}
        -o "help/${lang}/pentobi/" "${CMAKE_CURRENT_SOURCE_DIR}/custom.xsl"
        index_${lang}.docbook
        DEPENDS "index_${lang}.docbook" ${DOCBOOK_SRC}
        )
endforeach()

add_custom_command(OUTPUT "help/C/pentobi/index.html"
    COMMAND "${XSLTPROC}" --nonet --novalid --path "${DOCBOOK_XSL}/html"
    -o "help/C/pentobi/" "${CMAKE_CURRENT_SOURCE_DIR}/custom.xsl"
    "${CMAKE_CURRENT_SOURCE_DIR}/index.docbook"
    COMMAND ${CMAKE_COMMAND} -E copy
    "${CMAKE_CURRENT_SOURCE_DIR}/figures/*.png" "help/C/pentobi/"
    COMMAND ${CMAKE_COMMAND} -E copy
    "${CMAKE_CURRENT_SOURCE_DIR}/figures/*.jpg" "help/C/pentobi/"
    COMMAND ${CMAKE_COMMAND} -E copy
    "${CMAKE_CURRENT_SOURCE_DIR}/figures/stylesheet.css" "help/C/pentobi/"
    DEPENDS ${DOCBOOK_SRC}
    )

add_custom_target(pentobi-help ALL DEPENDS
    "help/C/pentobi/index.html" ${index_files}
    )

install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/help"
    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR} FILES_MATCHING PATTERN "*.css"
    PATTERN "*.html" PATTERN "*.png" PATTERN "*.jpg")

=== pentobi/unix/CMakeLists.txt ===
find_package(Gettext 0.18 REQUIRED)
find_program(ITSTOOL itstool)
if(NOT ITSTOOL)
    message(FATAL_ERROR "itstool not found")
endif()
get_filename_component(GETTEXT_BIN_DIR ${GETTEXT_MSGFMT_EXECUTABLE} DIRECTORY)
get_filename_component(GETTEXT_INSTALL_DIR ${GETTEXT_BIN_DIR} DIRECTORY)
find_file(METAINFO_ITS NAMES metainfo.its appdata.its
    HINTS ${GETTEXT_INSTALL_DIR}/share/gettext/its
    )
if(NOT METAINFO_ITS)
    message(FATAL_ERROR "metainfo.its not found (install appstream)")
endif()
find_program(RSVG_CONVERT rsvg-convert)
if(NOT RSVG_CONVERT)
    message(FATAL_ERROR "rsvg-convert not found (install librsvg2-bin)")
endif()
find_program(XSLTPROC xsltproc)
if(NOT XSLTPROC)
    message(FATAL_ERROR "xsltproc not found")
endif()
find_path(DOCBOOK_XSL manpages/docbook.xsl
    HINTS /usr/share/xml/docbook/stylesheet/docbook-xsl
    /usr/local/share/xml/docbook/stylesheet/docbook-xsl
    /usr/share/xsl/docbook /usr/local/share/xsl/docbook
    )
if(NOT DOCBOOK_XSL)
    message(FATAL_ERROR "docbook-xsl not found")
endif()

# Binary gettext files

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/po/LINGUAS" linguas)
string(REGEX REPLACE "\n" ";" linguas "${linguas}")

foreach(lang ${linguas})
    add_custom_command(OUTPUT ${lang}.mo
        COMMAND "${GETTEXT_MSGFMT_EXECUTABLE}" -o ${lang}.mo
        "${CMAKE_CURRENT_SOURCE_DIR}/po/${lang}.po"
        DEPENDS po/${lang}.po
        )
    list(APPEND po_files po/${lang}.po)
    list(APPEND mo_files ${lang}.mo)
endforeach()

# Icons

add_custom_command(OUTPUT pentobi.png
    COMMAND "${RSVG_CONVERT}"
    "${CMAKE_CURRENT_SOURCE_DIR}/../icon/pentobi-48.svg"
    > pentobi.png
    DEPENDS ../icon/pentobi-48.svg)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/pentobi.png"
    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps)
install(FILES ../icon/pentobi-128.svg
    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps
    RENAME pentobi.svg)

add_custom_command(OUTPUT application-x-blokus-sgf.png
    COMMAND "${RSVG_CONVERT}"
    "${CMAKE_CURRENT_SOURCE_DIR}/application-x-blokus-sgf-48.svg"
    > application-x-blokus-sgf.png
    DEPENDS application-x-blokus-sgf-48.svg)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/application-x-blokus-sgf.png"
    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/mimetypes)
install(FILES application-x-blokus-sgf-128.svg
    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/mimetypes
    RENAME application-x-blokus-sgf.svg)

# Desktop entry

configure_file(io.sourceforge.pentobi.desktop.in
    io.sourceforge.pentobi.desktop.in.2 @ONLY)
add_custom_command(OUTPUT io.sourceforge.pentobi.desktop
    COMMAND "${GETTEXT_MSGFMT_EXECUTABLE}" --desktop
    -d "${CMAKE_CURRENT_SOURCE_DIR}/po"
    --template io.sourceforge.pentobi.desktop.in.2
    -o io.sourceforge.pentobi.desktop
    DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/io.sourceforge.pentobi.desktop.in.2"
    ${po_files} po/LINGUAS)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/io.sourceforge.pentobi.desktop
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications")

# AppData

configure_file(io.sourceforge.pentobi.appdata.xml.in
    io.sourceforge.pentobi.appdata.xml @ONLY)
add_custom_command(OUTPUT io.sourceforge.pentobi.appdata.translated.xml
    COMMAND "${GETTEXT_MSGFMT_EXECUTABLE}" --xml
    -d "${CMAKE_CURRENT_SOURCE_DIR}/po"
    --template io.sourceforge.pentobi.appdata.xml
    -o io.sourceforge.pentobi.appdata.translated.xml
    DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/io.sourceforge.pentobi.appdata.xml"
    ${po_files} po/LINGUAS
    )

install(
    FILES
    "${CMAKE_CURRENT_BINARY_DIR}/io.sourceforge.pentobi.appdata.translated.xml"
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo"
    RENAME io.sourceforge.pentobi.appdata.xml
    )

# Shared MIME info

# Use itstool until shared-mime-info includes its/loc files for gettext (see
# also https://gitlab.freedesktop.org/xdg/shared-mime-info/merge_requests/4)
add_custom_command(OUTPUT pentobi-mime.xml
    COMMAND "${ITSTOOL}"
    -j "${CMAKE_CURRENT_SOURCE_DIR}/pentobi-mime.xml.in"
    -o pentobi-mime.xml ${mo_files}
    DEPENDS pentobi-mime.xml.in ${mo_files} po/LINGUAS
    )
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/pentobi-mime.xml"
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/mime/packages")

# Man page

set(man_files "pentobi.6")
foreach(lang ${linguas})
    list(APPEND man_files "${lang}/pentobi.6")
endforeach()

configure_file(pentobi-manpage.docbook.in pentobi-manpage.docbook @ONLY)
add_custom_command(OUTPUT pentobi.6
    COMMAND "${XSLTPROC}" --nonet --novalid --path "${DOCBOOK_XSL}/manpages"
    "${CMAKE_CURRENT_SOURCE_DIR}/manpage.xsl" pentobi-manpage.docbook
    DEPENDS manpage.xsl "${CMAKE_CURRENT_BINARY_DIR}/pentobi-manpage.docbook"
    )
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/pentobi.6"
    DESTINATION "${CMAKE_INSTALL_MANDIR}/man6")
foreach(lang ${linguas})
    add_custom_command(OUTPUT ${lang}/pentobi-manpage.docbook
        COMMAND ${CMAKE_COMMAND} -E make_directory ${lang}
        COMMAND "${ITSTOOL}" -l ${lang} -m ${lang}.mo
        -o ${lang}/pentobi-manpage.docbook
        -i "${CMAKE_CURRENT_SOURCE_DIR}/manpage.its"
        pentobi-manpage.docbook
        DEPENDS ${lang}.mo "${CMAKE_CURRENT_BINARY_DIR}/pentobi-manpage.docbook"
        )
    add_custom_command(OUTPUT ${lang}/pentobi.6
        COMMAND "${XSLTPROC}" --nonet --novalid
        --path "${DOCBOOK_XSL}/manpages" -o ${lang}/
        "${CMAKE_CURRENT_SOURCE_DIR}/manpage.xsl"
        ${lang}/pentobi-manpage.docbook
        DEPENDS manpage.xsl ${lang}/pentobi-manpage.docbook
        )
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${lang}/pentobi.6"
        DESTINATION "${CMAKE_INSTALL_MANDIR}/${lang}/man6")
endforeach()

# User manual

install(DIRECTORY help DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}
    FILES_MATCHING PATTERN "*.css" PATTERN "*.html" PATTERN "*.png"
    PATTERN "*.jpg")

# Target

add_custom_target(pentobi-unix ALL DEPENDS
    io.sourceforge.pentobi.desktop
    io.sourceforge.pentobi.appdata.translated.xml
    pentobi-mime.xml
    pentobi.png
    application-x-blokus-sgf.png
    ${man_files}
    )

=== debian/changelog ===
pentobi (17.1-1) unstable; urgency=medium

  * New upstream release. Upload to unstable as the freeze is over.
  * Add new build-dependencies: appstream, docbook-xsl, gettext, itstool,
    librsvg2-bin, xsltproc.
  * d/rules: PENTOBI_BUILD_TESTS was renamed to BUILD_TESTING.
  * d/*.install: thumbnailer metainfo file was removed upstream.
  * d/pentobi.docs: NEWS was renamed to NEWS.md.
  * Bump Standards-Version to 4.4.0. No changes needed.

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Sun, 07 Jul 2019 20:41:44 +0300

pentobi (16.3-1) experimental; urgency=medium

  * New upstream release.
    - QtQuickCompiler was disabled to avoid the need for recompilation
      for different versions of Qt (LP: #1824560).

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Tue, 23 Apr 2019 11:14:26 +0300

=== debian/control ===
Source: pentobi
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Dean Evans <dean@codemonkies.net>,
           Juhani Numminen <juhaninumminen0@gmail.com>
Build-Depends: appstream,
               cmake,
               debhelper-compat (= 12),
               docbook-xsl,
               extra-cmake-modules,
               gettext,
               itstool,
               libkf5kio-dev,
               libqt5svg5-dev,
               libqt5webview5-dev [amd64 arm64 armhf i386 mipsel],
               librsvg2-bin,
               qtdeclarative5-dev,
               qtquickcontrols2-5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               xsltproc
Rules-Requires-Root: no
Standards-Version: 4.4.0
Homepage: https://pentobi.sourceforge.io
Vcs-Git: https://salsa.debian.org/games-team/pentobi.git
Vcs-Browser: https://salsa.debian.org/games-team/pentobi

Package: pentobi
Architecture: any
Depends: qml-module-qt-labs-folderlistmodel,
         qml-module-qt-labs-settings,
         qml-module-qtquick-controls2,
         qml-module-qtquick-layouts,
         qml-module-qtquick-window2,
         qml-module-qtquick2,
         qml-module-qtwebview [amd64 arm64 armhf i386 mipsel],
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: www-browser [!amd64 !arm64 !armhf !i386 !mipsel]
Suggests: pentobi-kde-thumbnailer
Description: clone of the strategy board game Blokus
 Pentobi is a strategy board game played on a square grid board using playing
 pieces in the shapes of polyominoes, similar to Tetris pieces.  The aim of the
 game is to place all of your pieces while trying to block your opponent from
 placing all of theirs.
 .
 The game ends when no one can place any more pieces and the winner is
 determined by calculating the score based on the points of any remaining
 playing pieces. Bonus points are added for playing every piece and additional
 bonus points are added if the monomino, the 1x1 square piece, is played last.

Package: pentobi-kde-thumbnailer
Architecture: any
Multi-Arch: same
Section: kde
Depends: ${misc:Depends}, ${shlibs:Depends}
Enhances: dolphin, konqueror
Description: clone of the strategy board game Blokus - KDE thumbnailer
 Pentobi is a strategy board game played on a square grid board using playing
 pieces in the shapes of polyominoes, similar to Tetris pieces.  The aim of the
 game is to place all of your pieces while trying to block your opponent from
 placing all of theirs.
 .
 This package contains a KDE plugin to display thumbnails of Pentobi game files.

=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,7 @@
 		-DCMAKE_INSTALL_DATADIR=/usr/share/games \
 		-DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
 		-DPENTOBI_BUILD_KDE_THUMBNAILER=ON \
-		-DPENTOBI_BUILD_TESTS=ON
+		-DBUILD_TESTING=ON
 
 # dh_makeshlibs not needed, the KDE thumbnailer .so file is a plugin.
 override_dh_makeshlibs:

## pentobi 17.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.1.0)
 
 project(Pentobi)
-set(PENTOBI_VERSION 17.1)
-set(PENTOBI_RELEASE_DATE 2019-06-12)
+set(PENTOBI_VERSION 17.3)
+set(PENTOBI_RELEASE_DATE 2019-11-05)
 
 cmake_policy(SET CMP0043 NEW)
 cmake_policy(SET CMP0071 NEW)
@@ -15,6 +15,8 @@
 option(PENTOBI_BUILD_KDE_THUMBNAILER "Build KDE thumbnailer" OFF)
 option(PENTOBI_OPEN_HELP_EXTERNALLY "Force using web browser for displaying help" OFF)
 option(BUILD_TESTING "Build tests" OFF)
+
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")
 
 if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
   message(STATUS "No build type selected, default to Release")

=== learn_tool/CMakeLists.txt ===
find_package(Threads)

add_executable(learn-tool Main.cpp)

target_link_libraries(learn-tool
  pentobi_mcts
  Threads::Threads
)

=== libboardgame_mcts/CMakeLists.txt ===
option(LIBBOARDGAME_MCTS_SINGLE_THREAD
    "Slightly faster MCTS search if only single-threaded search is used" OFF)

find_package(Threads)

add_library(boardgame_mcts INTERFACE)

if(LIBBOARDGAME_MCTS_SINGLE_THREAD)
  target_compile_definitions(boardgame_mcts INTERFACE
      LIBBOARDGAME_MCTS_SINGLE_THREAD)
endif()

target_include_directories(boardgame_mcts INTERFACE ..)

target_link_libraries(boardgame_mcts INTERFACE Threads::Threads)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== libpentobi_base/CMakeLists.txt ===
add_library(pentobi_base STATIC
  BoardConst.h
  BoardConst.cpp
  Board.h
  Board.cpp
  BoardUpdater.h
  BoardUpdater.cpp
  BoardUtil.h
  BoardUtil.cpp
  Book.h
  Book.cpp
  CallistoGeometry.h
  CallistoGeometry.cpp
  Color.h
  ColorMap.h
  ColorMove.h
  Game.h
  Game.cpp
  GembloQGeometry.h
  GembloQGeometry.cpp
  GembloQTransform.h
  GembloQTransform.cpp
  Geometry.h
  Grid.h
  Marker.h
  Move.h
  MoveInfo.h
  MoveList.h
  MoveMarker.h
  MovePoints.h
  NexosGeometry.h
  NexosGeometry.cpp
  NodeUtil.h
  NodeUtil.cpp
  PentobiSgfUtil.h
  PentobiSgfUtil.cpp
  PentobiTree.h
  PentobiTree.cpp
  PentobiTreeWriter.h
  PentobiTreeWriter.cpp
  Piece.h
  PieceInfo.h
  PieceInfo.cpp
  PieceMap.h
  PieceTransformsClassic.h
  PieceTransformsClassic.cpp
  PieceTransformsGembloQ.h
  PieceTransformsGembloQ.cpp
  PieceTransforms.h
  PieceTransforms.cpp
  PieceTransformsTrigon.h
  PieceTransformsTrigon.cpp
  PlayerBase.h
  PlayerBase.cpp
  Point.h
  PointList.h
  PointState.h
  PrecompMoves.h
  ScoreUtil.h
  Setup.h
  StartingPoints.h
  StartingPoints.cpp
  SymmetricPoints.h
  SymmetricPoints.cpp
  TreeUtil.h
  TreeUtil.cpp
  TrigonGeometry.h
  TrigonGeometry.cpp
  TrigonTransform.h
  TrigonTransform.cpp
  Variant.h
  Variant.cpp
)

target_link_libraries(pentobi_base boardgame_base)
target_include_directories(pentobi_base PUBLIC ..)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== libpentobi_kde_thumbnailer/CMakeLists.txt ===
# libpentobi_kde_thumbnailer contains the files needed by
# the pentobi_kde_thumbnailer plugin compiled with shared library options
# (usually -fPIC) because this is required for building shared libraries on
# some targets (e.g. x86_64).
#
# The alternative would be to add -fPIC to the global compiler flags even for
# executables but this slows down Pentobi's search by 10% on some targets.
#
# Adding the source files directly to pentobi_kde_thumbnailer/CMakeList.txt is
# not possible because the KDE CMake macros add -fno-exceptions to the
# compiler flags, which causes errors in the Pentobi sources that use
# exceptions (which should be fine as long as no exceptions are thrown
# from the thumbnailer plugin functions).

find_package(Qt5Gui 5.9 REQUIRED)

add_library(pentobi_kde_thumbnailer STATIC
  ../libboardgame_base/Assert.cpp
  ../libboardgame_base/Reader.cpp
  ../libboardgame_base/SgfError.cpp
  ../libboardgame_base/SgfNode.cpp
  ../libboardgame_base/SgfTree.cpp
  ../libboardgame_base/StringRep.cpp
  ../libboardgame_base/StringUtil.cpp
  ../libboardgame_base/TreeReader.cpp
  ../libpentobi_base/CallistoGeometry.cpp
  ../libpentobi_base/GembloQGeometry.cpp
  ../libpentobi_base/NexosGeometry.cpp
  ../libpentobi_base/NodeUtil.cpp
  ../libpentobi_base/TrigonGeometry.cpp
  ../libpentobi_base/Variant.cpp
  ../libpentobi_paint/Paint.cpp
  ../libpentobi_thumbnail/CreateThumbnail.cpp
)

target_include_directories(pentobi_kde_thumbnailer PRIVATE ..)

target_compile_options(pentobi_kde_thumbnailer PRIVATE
    ${CMAKE_SHARED_LIBRARY_CXX_FLAGS})

target_compile_definitions(pentobi_kde_thumbnailer PRIVATE
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x051200)

target_link_libraries(pentobi_kde_thumbnailer Qt5::Gui)

=== libpentobi_paint/CMakeLists.txt ===
find_package(Qt5Gui 5.9 REQUIRED)

add_library(pentobi_paint STATIC
Paint.cpp
Paint.h
)

target_compile_definitions(pentobi_paint PRIVATE
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x051200)

target_link_libraries(pentobi_paint pentobi_base Qt5::Gui)

=== libpentobi_thumbnail/CMakeLists.txt ===
find_package(Qt5Gui 5.9 REQUIRED)

add_library(pentobi_thumbnail STATIC
    CreateThumbnail.h
    CreateThumbnail.cpp
    )

target_compile_definitions(pentobi_thumbnail PRIVATE
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x051200)

target_link_libraries(pentobi_thumbnail pentobi_paint)

=== pentobi/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,7 @@
 
 qt5_add_translation(pentobi_QM
     qml/i18n/qml_de.ts
+    qml/i18n/qml_es.ts
     qml/i18n/qml_fr.ts
     qml/i18n/qml_nb_NO.ts
     qml/i18n/qml_zh_CN.ts
@@ -75,8 +76,10 @@
     target_link_libraries(pentobi Qt5::WebView)
 else()
     if(NOT Qt5WebView_FOUND AND NOT PENTOBI_OPEN_HELP_EXTERNALLY)
-        message(WARNING
-            "Qt5WebView not found, setting PENTOBI_OPEN_HELP_EXTERNALLY")
+        message(FATAL_ERROR
+            "Qt5WebView not found. Install Qt5WebView or set"
+            " PENTOBI_OPEN_HELP_EXTERNALLY to make Pentobi use an external"
+            " browser for displaying help.")
     endif()
     target_compile_definitions(pentobi PRIVATE PENTOBI_OPEN_HELP_EXTERNALLY)
 endif()

=== pentobi_kde_thumbnailer/CMakeLists.txt ===
find_package(ECM REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECompilerSettings)
include(KDECMakeSettings)

find_package(KF5 REQUIRED COMPONENTS KIO)

add_library(pentobi-thumbnail MODULE
  PentobiThumbCreator.h
  PentobiThumbCreator.cpp
)

target_include_directories(pentobi-thumbnail PRIVATE "${CMAKE_SOURCE_DIR}")

target_link_libraries(pentobi-thumbnail
  pentobi_kde_thumbnailer
  KF5::KIOWidgets
)

install(TARGETS pentobi-thumbnail DESTINATION ${PLUGIN_INSTALL_DIR})
install(FILES pentobi-thumbnail.desktop DESTINATION ${SERVICES_INSTALL_DIR})

=== pentobi_thumbnailer/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 find_package(Qt5Core 5.11 REQUIRED)
 find_package(Qt5LinguistTools 5.11 REQUIRED)
 find_package(Gettext 0.18 REQUIRED)
+find_package(DocBookXSL REQUIRED)
 find_program(ITSTOOL itstool)
 if(NOT ITSTOOL)
     message(FATAL_ERROR "itstool not found")
@@ -8,14 +9,6 @@
 find_program(XSLTPROC xsltproc)
 if(NOT XSLTPROC)
     message(FATAL_ERROR "xsltproc not found")
-endif()
-find_path(DOCBOOK_XSL manpages/docbook.xsl
-    HINTS /usr/share/xml/docbook/stylesheet/docbook-xsl
-    /usr/local/share/xml/docbook/stylesheet/docbook-xsl
-    /usr/share/xsl/docbook /usr/local/share/xsl/docbook
-    )
-if(NOT DOCBOOK_XSL)
-    message(FATAL_ERROR "docbook-xsl not found")
 endif()
 
 file(READ "${CMAKE_CURRENT_SOURCE_DIR}/po/LINGUAS" linguas)
@@ -38,6 +31,7 @@
 
 qt5_add_translation(pentobi_thumbnailer_QM
     i18n/de.ts
+    i18n/es.ts
     OPTIONS -removeidentical -nounfinished
     )
 add_custom_command(
@@ -76,7 +70,7 @@
 configure_file(pentobi-thumbnailer-manpage.docbook.in
     pentobi-thumbnailer-manpage.docbook @ONLY)
 add_custom_command(OUTPUT pentobi-thumbnailer.6
-    COMMAND "${XSLTPROC}" --nonet --novalid --path "${DOCBOOK_XSL}/manpages"
+    COMMAND "${XSLTPROC}" --nonet --novalid --path "${DOCBOOKXSL_DIR}/manpages"
     "${CMAKE_CURRENT_SOURCE_DIR}/../pentobi/unix/manpage.xsl"
     pentobi-thumbnailer-manpage.docbook
     DEPENDS
@@ -96,7 +90,7 @@
         )
     add_custom_command(OUTPUT ${lang}/pentobi-thumbnailer.6
         COMMAND "${XSLTPROC}" --nonet --novalid
-        --path "${DOCBOOK_XSL}/manpages" -o ${lang}/
+        --path "${DOCBOOKXSL_DIR}/manpages" -o ${lang}/
         "${CMAKE_CURRENT_SOURCE_DIR}/../pentobi/unix/manpage.xsl"
         ${lang}/pentobi-thumbnailer-manpage.docbook
         DEPENDS
@@ -106,4 +100,3 @@
     install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${lang}/pentobi-thumbnailer.6"
         DESTINATION "${CMAKE_INSTALL_MANDIR}/${lang}/man6")
 endforeach()
-

=== pentobi/docbook/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,5 @@
 find_package(Gettext 0.18 REQUIRED)
+find_package(DocBookXSL REQUIRED)
 find_program(ITSTOOL itstool)
 if(NOT ITSTOOL)
     message(FATAL_ERROR "itstool not found")
@@ -6,15 +7,6 @@
 find_program(XSLTPROC xsltproc)
 if(NOT XSLTPROC)
     message(FATAL_ERROR "xsltproc not found")
-endif()
-find_path(DOCBOOK_XSL html/chunk.xsl
-    HINTS /usr/share/xml/docbook/stylesheet/docbook-xsl
-    /usr/local/share/xml/docbook/stylesheet/docbook-xsl
-    /usr/share/xsl/docbook /usr/local/share/xsl/docbook
-    /usr/share/xml/docbook/stylesheet/nwalsh/current
-    )
-if(NOT DOCBOOK_XSL)
-    message(FATAL_ERROR "docbook-xsl not found")
 endif()
 
 file(READ "${CMAKE_CURRENT_SOURCE_DIR}/po/LINGUAS" linguas)
@@ -59,7 +51,7 @@
         DEPENDS index.docbook ${lang}.mo
         )
     add_custom_command(OUTPUT "help/${lang}/pentobi/index.html"
-        COMMAND "${XSLTPROC}" --nonet --novalid --path "${DOCBOOK_XSL}/html"
+        COMMAND "${XSLTPROC}" --nonet --novalid --path "${DOCBOOKXSL_DIR}/html"
         --stringparam l10n.gentext.language ${lang}
         -o "help/${lang}/pentobi/" "${CMAKE_CURRENT_SOURCE_DIR}/custom.xsl"
         index_${lang}.docbook
@@ -68,7 +60,7 @@
 endforeach()
 
 add_custom_command(OUTPUT "help/C/pentobi/index.html"
-    COMMAND "${XSLTPROC}" --nonet --novalid --path "${DOCBOOK_XSL}/html"
+    COMMAND "${XSLTPROC}" --nonet --novalid --path "${DOCBOOKXSL_DIR}/html"
     -o "help/C/pentobi/" "${CMAKE_CURRENT_SOURCE_DIR}/custom.xsl"
     "${CMAKE_CURRENT_SOURCE_DIR}/index.docbook"
     COMMAND ${CMAKE_COMMAND} -E copy

=== debian/changelog ===
pentobi (17.3-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:22:41 +0100

pentobi (17.3-1) unstable; urgency=medium

  * New upstream release.
  * d/rules: Build system now requires us to specify a cmake flag on
    architectures that do not have Qt WebView.
  * Bump Standards-Version to 4.4.1. No changes needed.

 -- Juhani Numminen <juhaninumminen0@gmail.com>  Sun, 15 Dec 2019 16:33:54 +0200

=== debian/control ===
--- 
+++ 
@@ -21,7 +21,7 @@
                qttools5-dev-tools,
                xsltproc
 Rules-Requires-Root: no
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Homepage: https://pentobi.sourceforge.io
 Vcs-Git: https://salsa.debian.org/games-team/pentobi.git
 Vcs-Browser: https://salsa.debian.org/games-team/pentobi

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+include /usr/share/dpkg/architecture.mk
 
 export QT_SELECT = qt5
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
@@ -9,16 +11,23 @@
   export DEB_CXXFLAGS_MAINT_APPEND = -O3
 endif
 
+# Use an external web browser where Qt5WebView is not available.
+WEBVIEW_ARCHS = amd64 arm64 armhf i386 mipsel
+ifeq (,$(filter $(WEBVIEW_ARCHS),$(DEB_HOST_ARCH)))
+  WEBVIEW_FLAG = -DPENTOBI_OPEN_HELP_EXTERNALLY=ON
+endif
+
 %:
 	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
+		-DBUILD_TESTING=ON \
 		-DCMAKE_INSTALL_BINDIR=/usr/games \
 		-DCMAKE_INSTALL_DATADIR=/usr/share/games \
 		-DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
 		-DPENTOBI_BUILD_KDE_THUMBNAILER=ON \
-		-DBUILD_TESTING=ON
+		$(WEBVIEW_FLAG)
 
 # dh_makeshlibs not needed, the KDE thumbnailer .so file is a plugin.
 override_dh_makeshlibs:
